<template>
  <v-container class="forgot-password-container" fluid fill-height>
    <v-row no-gutters>
      <v-col cols="12">
        <v-card ref="forgot" class="forgot-password-content elevation-0 px-3 px-sm-7 px-md-5 py-5 py-sm-10 py-md-5 rounded" tile>
          <v-container class="mt-n16 mt-sm-n16 mt-md-0" fluid fill-height>
            <v-row justify="center" align="center">
              <v-col cols="12">
                  <v-card class="d-flex flex-column elevation-0" style="height: 100%;">
                    <div class="mb-10">
                      <v-img class="mx-auto" max-width="200" :src="require('~/assets/images/logo.png')" contain></v-img>
                    </div>
                    <div class="text-center" v-if="success">
                      <h1>Verified</h1>
                      <p>Congratulations! You have successfully verified the account</p>
                    </div>
                    <div class="text-center" v-else>
                      <h1>Something went wrong!</h1>
                      <p>{{ status }}</p>
                    </div>
                    <div class="d-flex flex-column">
                      <div>
                          <v-btn type="submit" block class="white--text" color="#291470" elevation="0" large :to="{ name: 'login' }">Go to log in</v-btn>
                      </div>
                    </div>
                    <div class="mt-5 mt-sm-8 mt-md-10 text-center">
                      <p class="mb-0">2021 NKTI. All rights reserved.</p>
                    </div>
                  </v-card>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import axios from 'axios'

const qs = params => Object.keys(params).map(key => `${key}=${params[key]}`).join('&')

export default {
  middleware: 'guest',
  
  layout: 'simple',

  metaInfo () {
    return { title: this.$t('verify_email') }
  },

  mounted () {
    var x = this.$vuetify.breakpoint.name;
    if(x == "sm"){
      this.$refs.forgot.$el.classList.add('small-device')
    }
  },

  watch: {
    '$vuetify.breakpoint.name'(v){
      if(v == 'xs' || v == 'sm'){
        this.$refs.forgot.$el.classList.add('small-device')
      }else{
        this.$refs.forgot.$el.classList.remove('small-device')
      }
    }
  },

  async asyncData ({ params, query }) {
    try {
      const { data } = await axios.post(`/email/verify/${params.id}?${qs(query)}`)

      return { success: true, status: data.status }
    } catch (e) {
      return { success: false, status: e.response.status == '429' ? 'Too many attempts' : e.response.data.status }
    }
  }
}
</script>

<style lang="scss" scoped>
  .forgot-password-container{
    background: #E5E5E5;
    margin: 0 auto;
    width: 100vw;
    .forgot-password-content {
      max-width: 600px;
      width: 90vw;
      margin: 0 auto;
    }
    .forgot-password-content.small-device {
      position: fixed;
      top: 0px;
      left: 0px;
      width: 100vw;
      height: 100vh;
    }
  }
</style>
